import { NativeModules, NativeEventEmitter, Platform } from 'react-native';
const GardenModule = NativeModules.GardenModule;
const { STATUSBAR_HEIGHT, TOOLBAR_HEIGHT, EVENT_STATUSBAR_FRAME_CHANGE } = GardenModule.getConstants();
let _statusBarHeight = STATUSBAR_HEIGHT;
if (Platform.OS === 'ios') {
    const GardenEventReceiver = new NativeEventEmitter(GardenModule);
    GardenEventReceiver.addListener(EVENT_STATUSBAR_FRAME_CHANGE, ({ statusBarHeight: height }) => {
        _statusBarHeight = height;
    });
}
function statusBarHeight() {
    return _statusBarHeight;
}
function toolbarHeight() {
    return TOOLBAR_HEIGHT;
}
function topBarHeight() {
    return statusBarHeight() + toolbarHeight();
}
export { statusBarHeight, toolbarHeight, topBarHeight };
export default GardenModule;
