import { Route, RouteGraph } from './Route';
declare function getConstants(): {
    RESULT_OK: number;
    RESULT_CANCEL: number;
    RESULT_BLOCK: number;
};
declare function startRegisterReactComponent(): void;
declare function endRegisterReactComponent(): void;
declare function registerReactComponent(appKey: string, options: object): void;
declare function signalFirstRenderComplete(sceneId: string): void;
declare function setResult(sceneId: string, resultCode: number, data: object | null): void;
declare function setRoot(layout: object, sticky: boolean): Promise<boolean>;
declare function dispatch(sceneId: string, action: string, params: object): Promise<boolean>;
declare function currentTab(sceneId: string): Promise<number>;
declare function isStackRoot(sceneId: string): Promise<boolean>;
declare function findSceneIdByModuleName(moduleName: string): Promise<string | null>;
declare function currentRoute(): Promise<Route>;
declare function routeGraph(): Promise<RouteGraph[]>;
declare const _default: {
    getConstants: typeof getConstants;
    startRegisterReactComponent: typeof startRegisterReactComponent;
    endRegisterReactComponent: typeof endRegisterReactComponent;
    registerReactComponent: typeof registerReactComponent;
    signalFirstRenderComplete: typeof signalFirstRenderComplete;
    setResult: typeof setResult;
    setRoot: typeof setRoot;
    dispatch: typeof dispatch;
    currentTab: typeof currentTab;
    isStackRoot: typeof isStackRoot;
    findSceneIdByModuleName: typeof findSceneIdByModuleName;
    currentRoute: typeof currentRoute;
    routeGraph: typeof routeGraph;
};
export default _default;
