import { NativeModules } from 'react-native';
const NavigationModule = NativeModules.NavigationModule;
function getConstants() {
    return NavigationModule.getConstants();
}
function startRegisterReactComponent() {
    NavigationModule.startRegisterReactComponent();
}
function endRegisterReactComponent() {
    NavigationModule.endRegisterReactComponent();
}
function registerReactComponent(appKey, options) {
    NavigationModule.registerReactComponent(appKey, options);
}
function signalFirstRenderComplete(sceneId) {
    NavigationModule.signalFirstRenderComplete(sceneId);
}
function setResult(sceneId, resultCode, data) {
    NavigationModule.setResult(sceneId, resultCode, data);
}
function setRoot(layout, sticky) {
    return new Promise(resolve => {
        NavigationModule.setRoot(layout, sticky, (_, success) => {
            resolve(success);
        });
    });
}
function dispatch(sceneId, action, params) {
    return new Promise(resolve => {
        NavigationModule.dispatch(sceneId, action, params, (_, result) => {
            resolve(result);
        });
    });
}
function currentTab(sceneId) {
    return new Promise(resolve => {
        NavigationModule.currentTab(sceneId, (_, result) => {
            resolve(result);
        });
    });
}
function isStackRoot(sceneId) {
    return new Promise(resolve => {
        NavigationModule.isStackRoot(sceneId, (_, result) => {
            resolve(result);
        });
    });
}
function findSceneIdByModuleName(moduleName) {
    return new Promise(resolve => {
        NavigationModule.findSceneIdByModuleName(moduleName, (_, result) => {
            resolve(result);
        });
    });
}
function currentRoute() {
    return new Promise(resolve => {
        NavigationModule.currentRoute((_, result) => {
            resolve(result);
        });
    });
}
function routeGraph() {
    return new Promise(resolve => {
        NavigationModule.routeGraph((_, result) => {
            resolve(result);
        });
    });
}
export default {
    getConstants,
    startRegisterReactComponent,
    endRegisterReactComponent,
    registerReactComponent,
    signalFirstRenderComplete,
    setResult,
    setRoot,
    dispatch,
    currentTab,
    isStackRoot,
    findSceneIdByModuleName,
    currentRoute,
    routeGraph,
};
