import type { Visibility, Layout, BuildInLayout } from './Route';
import type { NavigationItem } from './Options';
import { ResultType } from './Navigation';
export declare const NavigationContext: import("react").Context<any>;
interface NavigationState {
    params: {
        readonly [index: string]: any;
    };
}
interface PropsType {
    [index: string]: any;
}
export interface Navigator {
}
export declare class Navigator implements Navigator {
    sceneId: string;
    moduleName?: string | undefined;
    static of(sceneId: string): Navigator;
    static unmount: (sceneId: string) => void;
    static find(moduleName: string): Promise<Navigator | undefined>;
    static current(): Promise<Navigator>;
    constructor(sceneId: string, moduleName?: string | undefined);
    visibility: Visibility;
    readonly state: NavigationState;
    setParams: (params: {
        [index: string]: any;
    }) => void;
    push: <T extends ResultType, P extends PropsType = {}>(moduleName: string, props?: P, options?: NavigationItem) => Promise<[number, T]>;
    pushLayout: <T extends ResultType>(layout: BuildInLayout | Layout) => Promise<[number, T]>;
    pop: () => Promise<boolean>;
    popTo: (moduleName: string, inclusive?: boolean) => Promise<boolean>;
    popToRoot: () => Promise<boolean>;
    redirectTo: <P extends PropsType>(moduleName: string, props?: P, options?: NavigationItem) => Promise<boolean>;
    present: <T extends ResultType, P extends PropsType = {}>(moduleName: string, props?: P, options?: NavigationItem) => Promise<[number, T]>;
    presentLayout: <T extends ResultType>(layout: BuildInLayout | Layout) => Promise<[number, T]>;
    dismiss: () => Promise<boolean>;
    showModal: <T extends ResultType, P extends PropsType = {}>(moduleName: string, props?: P, options?: NavigationItem) => Promise<[number, T]>;
    showModalLayout: <T extends ResultType>(layout: BuildInLayout | Layout) => Promise<[number, T]>;
    hideModal: () => Promise<boolean>;
    setResult: <T extends ResultType>(resultCode: number, data?: T) => void;
    switchTab: (index: number, popToRoot?: boolean) => Promise<boolean>;
    toggleMenu: () => Promise<boolean>;
    openMenu: () => Promise<boolean>;
    closeMenu: () => Promise<boolean>;
    isStackRoot: () => Promise<boolean>;
}
export {};
