import Event from '../Event';
export default class BarButtonEventHandler {
    actions = {};
    keyPairs = {};
    actionIdGenerator = 0;
    bindBarButtonClickEvent(sceneId, item) {
        if (item === null || item === undefined) {
            return null;
        }
        return JSON.parse(JSON.stringify(item, (key, value) => {
            if (key !== 'action' || typeof value !== 'function') {
                return value;
            }
            const actionKey = 'ON_BAR_BUTTON_ITEM_CLICK_' + this.actionIdGenerator++;
            if (!this.keyPairs[sceneId]) {
                this.keyPairs[sceneId] = [];
            }
            this.keyPairs[sceneId].push(actionKey);
            this.actions[actionKey] = value;
            return actionKey;
        }));
    }
    unbindBarButtonClickEvent(sceneId) {
        const keys = this.keyPairs[sceneId];
        delete this.keyPairs[sceneId];
        if (keys) {
            keys.forEach(key => delete this.actions[key]);
        }
    }
    setBarButtonClickEventListener(handler) {
        Event.listenBarButtonItemClick((sceneId, action) => {
            const listeners = this.actions;
            if (listeners[action]) {
                handler(sceneId, listeners[action]);
            }
        });
    }
}
