import { NavigationItem } from '../Options';
import { BuildInLayout, Layout } from '../Route';
export interface DispatchParams {
    animated?: boolean;
    moduleName?: string;
    from?: string | number;
    to?: string | number;
    layout?: BuildInLayout | Layout;
    popToRoot?: boolean;
    requestCode?: number;
    props?: object;
    options?: NavigationItem;
    [index: string]: any;
}
interface InterceptParams {
    sceneId: string;
    from?: number | string;
    to?: number | string;
    props?: object;
}
export type NavigationInterceptor = (action: string, params: InterceptParams) => boolean | Promise<boolean>;
export default class DispatchCommandHandler {
    private interceptor;
    dispatch(sceneId: string, action: string, params: DispatchParams): Promise<boolean>;
    private intercept;
    setInterceptor(interceptor: NavigationInterceptor): void;
}
export {};
