import NavigationModule from '../NavigationModule';
export default class DispatchCommandHandler {
    interceptor = () => false;
    async dispatch(sceneId, action, params) {
        const { from, to, props } = params;
        const intercepted = await this.intercept(action, {
            sceneId,
            from,
            to,
            props,
        });
        if (intercepted) {
            return false;
        }
        return NavigationModule.dispatch(sceneId, action, params);
    }
    intercept(action, params) {
        if (!this.interceptor) {
            return Promise.resolve(false);
        }
        const result = this.interceptor(action, params);
        if (result instanceof Promise) {
            return result;
        }
        return Promise.resolve(result);
    }
    setInterceptor(interceptor) {
        this.interceptor = interceptor;
    }
}
