import Event from '../Event';
import NavigationModule from '../NavigationModule';
export default class LayoutCommandHandler {
    willSetRoot = () => { };
    didSetRoot = () => { };
    constructor() { }
    handleRootLayoutChange() {
        Event.listenWillSetRoot(() => {
            this.willSetRoot();
        });
        Event.listenDidSetRoot(() => {
            this.didSetRoot();
        });
    }
    setRoot(layout, sticky = false) {
        return NavigationModule.setRoot(layout, sticky);
    }
    setRootLayoutUpdateListener(willSetRoot = () => { }, didSetRoot = () => { }) {
        this.willSetRoot = willSetRoot;
        this.didSetRoot = didSetRoot;
    }
}
