import Event from '../Event';
export default class VisibilityEventHandler {
    listeners = {};
    globalListeners = [];
    constructor() { }
    handleComponentVisibility() {
        Event.listenComponentVisibility((sceneId, visibility) => {
            const listeners = this.listeners[sceneId];
            if (listeners) {
                listeners.forEach(listener => listener(visibility));
            }
            this.globalListeners.forEach(listener => listener(sceneId, visibility));
        });
    }
    addGlobalVisibilityEventListener(listener) {
        this.globalListeners.push(listener);
    }
    removeGlobalVisibilityEventListener(listener) {
        this.globalListeners = this.globalListeners.filter(l => l !== listener);
    }
    addVisibilityEventListener(sceneId, listener) {
        if (!this.listeners[sceneId]) {
            this.listeners[sceneId] = [];
        }
        this.listeners[sceneId].push(listener);
    }
    removeVisibilityEventListener(sceneId, listener) {
        if (this.listeners[sceneId]) {
            this.listeners[sceneId] = this.listeners[sceneId].filter(l => l !== listener);
        }
    }
}
