import { isTargetLocateIn } from './screen';
import Navigation from '../Navigation';
export function isDrawerGraph(graph) {
    return graph.layout === 'drawer';
}
export class DrawerRouteHandler {
    async process(graph, target) {
        if (!isDrawerGraph(graph)) {
            throw new Error(`${graph} is Not a DrawerGraph`);
        }
        const { children } = graph;
        const { moduleName, sceneId } = children[1];
        if (moduleName === target.moduleName) {
            await Navigation.dispatch(sceneId, 'openMenu');
            return [true, null];
        }
        if (isTargetLocateIn(children[0], target)) {
            Navigation.dispatch(sceneId, 'closeMenu', { from: moduleName });
            return [true, children[0]];
        }
        return [false, graph];
    }
}
