import { RouteHandler, RouteInterceptor } from '../Route';
import { NavigationItem } from '../Options';
interface IndexType {
    [index: string]: any;
}
declare class Router {
    constructor();
    private handlers;
    registerRouteHandler(layout: string, handler: RouteHandler): void;
    private convertConfigToData;
    private isRouteConfigInflated;
    private routeDataSet;
    private inflateRouteData;
    private interceptors;
    addInterceptor(interceptor: RouteInterceptor): void;
    removeInterceptor(interceptor: RouteInterceptor): void;
    private intercept;
    private resolveInterceptResult;
    private pathToRoute;
    private routeDependencies;
    private processRoute;
    open(path: string, props?: IndexType, options?: NavigationItem): Promise<void>;
}
export declare const router: Router;
export * from './drawer';
export * from './screen';
export * from './stack';
export * from './tabs';
