export function isScreenGraph(graph) {
    return graph.layout === 'screen';
}
function extractModuleNames(graph, set) {
    if (isScreenGraph(graph)) {
        set.push(graph.moduleName);
    }
    else {
        const children = graph.children;
        for (let i = 0; i < children.length; i++) {
            extractModuleNames(children[i], set);
        }
    }
}
export function isTargetLocateIn(graph, target) {
    const existings = [];
    extractModuleNames(graph, existings);
    const { dependencies, moduleName } = target;
    const expectations = [...dependencies, moduleName];
    return expectations.some(name => existings.includes(name));
}
export class ScreenRouteHandler {
    process(graph, target) {
        if (!isScreenGraph(graph)) {
            throw new Error(`${graph} is Not a ScreenGraph`);
        }
        if (graph.moduleName === target.moduleName) {
            return Promise.resolve([true, null]);
        }
        return Promise.resolve([false, graph]);
    }
}
