import { isTargetLocateIn } from './screen';
import Navigation from '../Navigation';
export function isTabsGraph(graph) {
    return graph.layout === 'tabs';
}
export class TabsRouteHandler {
    async process(graph, target) {
        if (!isTabsGraph(graph)) {
            throw new Error(`${graph} is NOT a TabsGraph`);
        }
        const { children, selectedIndex } = graph;
        for (let i = 0; i < children.length; i++) {
            if (isTargetLocateIn(children[i], target)) {
                if (selectedIndex !== i) {
                    await Navigation.dispatch(children[selectedIndex].sceneId, 'switchTab', {
                        from: selectedIndex,
                        to: i,
                        popToRoot: true,
                    });
                }
                return [true, children[i]];
            }
        }
        return [false, graph];
    }
}
